n, q, k = map(int, input().split())
favorite_permutation = list(map(int, input().split()))
tasks = list(range(1, n + 1))

for _ in range(q):
    l, r = map(int, input().split())
    # Изменение порядка дел в соответствии с любимой перестановкой
    modified_order = [favorite_permutation[i - 1] for i in tasks[l - 1:r]]
    # Назначение приоритетов делам
    modified_order.sort()
    # Замена измененного порядка обратно в список дел
    for i in range(l - 1, r):
        tasks[i] = modified_order[i - (l - 1)]

# Найдите дело, которое Юрик выполнит k-м по очереди
print(tasks[k - 1])
